#!/bin/bash
# set -e

# script that starts up kubernetes cluster, and does some basic qol

sudo swapoff -a # turn off swap memory
sudo kubeadm init --config kubeadm-config.yaml

if [[ $? -ne 0 ]] ; then
  # some error
  echo "Error! Stopping cluster set up"
  exit 1
fi

mkdir -p $HOME/.kube
sudo cp -f /etc/kubernetes/admin.conf $HOME/.kube/config
chown $(id -u):$(id -g) $HOME/.kube/config

# export KUBECONFIG=/etc/kubernetes/admin.conf

kubectl apply -f flannel.yml
kubectl taint nodes --all node-role.kubernetes.io/master-
kubectl label nodes $HOSTNAME name=base

# print join command again to clipboard
# kubeadm token create --print-join-command > ./tmpJoinCommand.txt
# now add config command to file
kubeadm token create --print-join-command | xclip -selection clipboard
# save that file to clipboard
# cat ./tmpJoinCommand.txt | xclip -selection clipboard
# rm ./tmpJoinCommand.txt
echo "set up done, join command copied (can ctrl-c now)"
exit 0

# dang pod cidr decided not to be assigned correctly, so follow links to assign it manually:
# https://stackoverflow.com/questions/52633215/kubernetes-worker-nodes-not-automatically-being-assigned-podcidr-on-kubeadm-join
